<template>
  <Dialog
    id="spellChecker"
    ref="dialogWindow"
    :title="'Орфография: ' + lang.desc"
    buttonText="Сохранить"
    @closed="closed"
  >
    <section style="margin: 6px" v-html="text"></section>
  </Dialog>
</template>
<script>
import Dialog from "../../../../src/controls/Dialog";

export default {
  name: "spellChecker",
  data() {
    return {
      isLoading: true,
      hasSuggests: false,
      text: "",
      lang: {}
    };
  },
  methods: {
    show(text, lang) {
      this.lang = lang;
      this.text = text.replace(/(?:\r\n|\r|\n)/g, "<br>");
      this.isLoading = true;

      this.$http
        .post(
          "https://translit.anufrij.de/spellcheck.php",
          { lang: lang.spell, text: text },
          { emulateJSON: true }
        )
        .then(response => {
          this.hasSuggests = response.data.length > 0;
          if (this.hasSuggests) {
            this.replaceSuggests(response.data);
            this.$nextTick(() => {});
          }
          this.isLoading = false;
        });
      this.$refs.dialogWindow.open();
    },
    close() {
      this.$refs.dialogWindow.close();
    },
    closed() {
      this.save();
      this.$emit("closed");
    },
    save() {
      let selects = document
        .getElementById("spellChecker")
        .getElementsByTagName("select");
      let return_value = this.text;
      for (let i = 0; i < selects.length; i++) {
        let select = selects[i];
        let regex = new RegExp(
          "<select id='" +
            select.id +
            "'>(<option( selected)?>((?!<).)*</option>)*</select>"
        );
        return_value = return_value.replace(regex, select.value);
      }
      return_value = return_value.replace(/<br>/g, "\n");
      this.$emit("saved", return_value);
    },
    replaceSuggests(suggests) {
      suggests.forEach(suggest => {
        let html =
          "<select id='" +
          suggest.word +
          "'><option selected>" +
          suggest.word +
          "</option>";
        suggest.suggest.forEach(alt => {
          html += "<option>" + alt + "</option>";
        });
        html += "</select>";

        let symbols =
          '(\\s|\\?|\\!|\\.|\\,|\\:|\\;|\\§|\\%|\\€|\\(|\\)|\\/|\\$|\\&|\\")';
        let symbol_start = "";
        let symbol_end = "";

        //One word
        let regex = new RegExp("^" + suggest.word + "(" + symbols + "*)$");
        let regexresult = regex.exec(this.text);
        if (regexresult != null) {
          if (regexresult.length > 1) {
            symbol_end = regexresult[1];
          }
          this.text = this.text.replace(regex, html + symbol_end);
          return;
        }

        //First line one word
        regex = new RegExp("^" + suggest.word + "(" + symbols + "*)<br>");
        regexresult = regex.exec(this.text);
        if (regexresult != null) {
          if (regexresult.length > 1) {
            symbol_end = regexresult[1];
          }
          this.text = this.text.replace(regex, html + symbol_end + "<br>");
          return;
        }

        //First word of whole text
        regex = new RegExp("^" + suggest.word + symbols);
        regexresult = regex.exec(this.text);
        if (regexresult != null) {
          if (regexresult.length > 1) {
            symbol_end = regexresult[1];
          }
          this.text = this.text.replace(regex, html + symbol_end);
          return;
        }

        //First word of a line
        regex = new RegExp("<br>" + suggest.word + "(" + symbols + "+)");
        regexresult = regex.exec(this.text);
        if (regexresult != null) {
          symbol_end = regexresult[1];
          this.text = this.text.replace(regex, "<br>" + html + symbol_end);
          return;
        }

        //All words into a text
        regex = new RegExp(symbols + suggest.word + symbols);
        regexresult = regex.exec(this.text);
        if (regexresult != null) {
          symbol_start = regexresult[1];
          symbol_end = regexresult[2];

          this.text = this.text.replace(
            regex,
            symbol_start + html + symbol_end
          );
          return;
        }

        //Last word of a line
        regex = new RegExp(" " + suggest.word + "(" + symbols + "*)<br>");
        regexresult = regex.exec(this.text);
        if (regexresult != null) {
          if (regexresult.length > 1) {
            symbol_end = regexresult[1];
          }
          this.text = this.text.replace(
            regex,
            " " + html + symbol_end + "<br>"
          );
          return;
        }

        //One line one word
        regex = new RegExp("<br>" + suggest.word + "(" + symbols + "*)<br>");
        regexresult = regex.exec(this.text);
        if (regexresult != null) {
          if (regexresult.length > 1) {
            symbol_end = regexresult[1];
          }
          this.text = this.text.replace(
            regex,
            "<br>" + html + symbol_end + "<br>"
          );
          return;
        }

        //Last word of whole text
        regex = new RegExp(
          symbols + "+" + suggest.word + "(" + symbols + "*)$"
        );
        regexresult = regex.exec(this.text);
        if (regexresult != null) {
          symbol_start = regexresult[1];
          if (regexresult.length > 2) {
            symbol_end = regexresult[2];
          }
          this.text = this.text.replace(
            regex,
            symbol_start + html + symbol_end
          );
          return;
        }

        //Last line one word
        regex = new RegExp("<br>" + suggest.word + "(" + symbols + "*)$");
        regexresult = regex.exec(this.text);
        if (regexresult != null) {
          if (regexresult.length > 1) {
            symbol_end = regexresult[1];
          }
          this.text = this.text.replace(regex, "<br>" + html + symbol_end);
          return;
        }
      });
    }
  },
  computed: {
    visible() {
      return this.$refs.dialogWindow.visible;
    }
  },
  components: {
    Dialog
  }
};
</script>